% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/rxode2.R
\name{rxGetModel}
\alias{rxGetModel}
\title{Get model properties without compiling it.}
\usage{
rxGetModel(
  model,
  calcSens = NULL,
  calcJac = NULL,
  collapseModel = NULL,
  indLin = FALSE
)
}
\arguments{
\item{model}{rxode2 specification}

\item{calcSens}{boolean indicating if rxode2 will calculate the
sensitivities according to the specified ODEs.}

\item{calcJac}{boolean indicating if rxode2 will calculate the
Jacobain according to the specified ODEs.}

\item{collapseModel}{boolean indicating if rxode2 will remove all
LHS variables when calculating sensitivities.}

\item{indLin}{Calculate inductive linearization matrices and
compile with inductive linearization support.}
}
\value{
rxode2 trans list
}
\description{
Get model properties without compiling it.
}
\author{
Matthew L. Fidler
}
\keyword{internal}
